package fi.fa.opplugin;

import com.alibaba.druid.util.StringUtils;
import fi.fa.opplugin.utils.ChangeDataUtils;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeginOperationTransactionArgs;
import kd.bos.exception.KDBizException;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import java.util.List;

//资产变更单中间表下推资产变更单
public class FaChangeMidOpPlugin extends AbstractOperationServicePlugIn {
    @Override
    public void beginOperationTransaction(BeginOperationTransactionArgs e) {
        super.beginOperationTransaction(e);
        DynamicObject[] dynamicObjects = e.getDataEntities();
        for (int i = 0; i < dynamicObjects.length; i++) {
            if (StringUtils.equals(e.getOperationKey(), "push")) {
                DynamicObject info = BusinessDataServiceHelper.loadSingle(dynamicObjects[i].getPkValue(), dynamicObjects[i].getDynamicObjectType().getName());
                String nckd_flag = info.getString("nckd_flag");
                if ("1".equals(nckd_flag)) {
                    throw new KDBizException("单据" + info.getString("number") + "已经下推生成了资产调拨单，不允许重复下推!");
                }else {
                    String dispatchType = info.getString("nckd_dispatch_type");
                    String direction = info.getString("nckd_direction");
                    String error = ChangeDataUtils.check(info);
                    if (!StringUtils.isEmpty(error)) {
                        this.operationResult.setShowMessage(true);
                        this.operationResult.setSuccess(false);
                        this.operationResult.setMessage(error);
                    }else {

                        if ("1".equals(dispatchType)) {
                            DynamicObject changeDept = BusinessDataServiceHelper.newDynamicObject("fa_change_dept");
                            //单据头
                            DynamicObject orgInfo = ChangeDataUtils.queryOrg(ChangeDataUtils.getOrg(info.getString("nckd_org_in")));
                            changeDept.set("org", orgInfo);//核算组织
                            changeDept.set("changedate", info.getDate("nckd_date_out"));//记账日期
                            changeDept.set("appliantid", ChangeDataUtils.getUser(info.getString("nckd_user_out")));//变更申请人
                            changeDept.set("remark", info.getString("nckd_reason"));//调出原因
                            changeDept.set("sourcetype", 2);//来源方式(5:API生成)
                            changeDept.set("changetype", ChangeDataUtils.queryChangeType(Long.parseLong("733953285719123968")));//变更类型，默认部门变更
                            changeDept.set("chtypedetail", "1");//变更类型明细默认实物变更1
                            changeDept.set("voucherflag", "A");//记账标识默认无需记账A
                            changeDept.set("billstatus", "A");//暂存
                            //调出方向
                            if("0".equals(direction)){
                                changeDept.set("creator", ChangeDataUtils.getUser(info.getString("nckd_user_out")));//创建人
                                changeDept.set("appliantid", ChangeDataUtils.getUser(info.getString("nckd_user_out")));//调拨申请人
                            }//调入方向
                            else if ("1".equals(direction)) {
                                changeDept.set("creator", ChangeDataUtils.getUser(info.getString("nckd_user_in")));//创建人
                                changeDept.set("appliantid", ChangeDataUtils.getUser(info.getString("nckd_user_in")));//调拨申请人
                            }
                            List<String> codeList =ChangeDataUtils.getCardNumber(info);
                            QFilter filter = new QFilter("number", QCP.in,codeList);
                            filter.and("isbak",  QCP.equals, "0");
                            DynamicObject[] card = BusinessDataServiceHelper.load("fa_card_real","id",new QFilter[] {filter});
                            for (int c = 0; c < card.length; c++) {
                                DynamicObject cardInfo = BusinessDataServiceHelper.loadSingle(card[c].getPkValue(), card[c].getDynamicObjectType().getName());
                                //查询财务卡片
                                DynamicObject fin = ChangeDataUtils.queryFinCard(cardInfo.getLong("id"));//财务卡片id
                                //创建变更字段分录
                                DynamicObjectCollection fieldentry = changeDept.getDynamicObjectCollection("fieldentry");

                                String deptAftervalue = ChangeDataUtils.getOrg(info.getString("nckd_dept_in")) == null ? null : ChangeDataUtils.getOrg(info.getString("nckd_dept_in")).toString();
                                String deptBeforevalue =  cardInfo.getDynamicObject("headusedept") == null ? null : String.valueOf(cardInfo.getDynamicObject("headusedept").getLong("id"));
                                if (!StringUtils.equals(deptBeforevalue, deptAftervalue)) {
                                    DynamicObject entry1 = fieldentry.addNew();
                                    entry1.set("realcard1", cardInfo);//资产编码
                                    entry1.set("depreuse1", ChangeDataUtils.queryDepreuse(Long.parseLong("418714318096331776")));//折旧用途默认
                                    entry1.set("currency1", 1);//币别
                                    entry1.set("basecurrency1", 1);//本币位
                                    entry1.set("assetnumber",cardInfo.getString("number"));//资产编码
                                    entry1.set("bizdate1", info.getDate("nckd_date_out"));//业务日期
                                    entry1.set("field", "fa_card_real.headusedept");//变更字段-部门
                                    entry1.set("beforevalue", deptBeforevalue);//变更前值
                                    entry1.set("aftervalue", deptAftervalue);//变更后值
                                    entry1.set("realcardmasterid", cardInfo);//实物卡片id
                                    entry1.set("fincard1", fin);//财务卡片
                                }

                                String userAftervalue = info.getString("nckd_used_user") == null ? null : String.valueOf(ChangeDataUtils.getUser(info.getString("nckd_used_user")).getLong("id"));
                                String userBeforevalue  = cardInfo.getDynamicObject("headuseperson") == null ? null : String.valueOf(ChangeDataUtils.getUser(info.getString("nckd_used_user")).getLong("id"));
                                if (!StringUtils.equals(userBeforevalue, userAftervalue)) {
                                    DynamicObject entry2 = fieldentry.addNew();
                                    entry2.set("realcard1", cardInfo);//资产编码
                                    entry2.set("depreuse1", ChangeDataUtils.queryDepreuse(Long.parseLong("418714318096331776")));//折旧用途默认
                                    entry2.set("currency1", 1);//币别
                                    entry2.set("basecurrency1", 1);//本币位
                                    entry2.set("assetnumber",cardInfo.getString("number"));//资产编码
                                    entry2.set("bizdate1", info.getDate("nckd_date_out"));//业务日期
                                    entry2.set("field", "fa_card_real.headuseperson");//变更字段-使用人
                                    entry2.set("beforevalue", userBeforevalue);//变更前值
                                    entry2.set("aftervalue", userAftervalue);//变更后值
                                    entry2.set("realcardmasterid", cardInfo);//实物卡片id
                                    entry2.set("fincard1", fin);//财务卡片
                                }


                                //创建实物变更分录
                                DynamicObjectCollection realentry = changeDept.getDynamicObjectCollection("realentry");
                                DynamicObject realentry1 = realentry.addNew();
                                realentry1.set("realcard", cardInfo.getLong("id"));//资产编码

                                //创建财务变更分录
                                DynamicObjectCollection finentry = realentry1.getDynamicObjectCollection("finentry");
                                DynamicObject finentry1 = finentry.addNew();
                                finentry1.set("depreuse", ChangeDataUtils.queryDepreuse(Long.parseLong("418714318096331776")));//折旧用途默认
                                finentry1.set("fincard", fin);
                                finentry1.set("bizdate", info.getDate("nckd_date_out"));

                            }
                            //执行保存-提交-审核
                            OperationResult saveResult = SaveServiceHelper.saveOperate("fa_change_dept", new DynamicObject[]{changeDept}, OperateOption.create());
                            if (saveResult.isSuccess()) {
                                info.set("nckd_flag", "1");
                                SaveServiceHelper.save(new DynamicObject[]{info});
                                this.operationResult.setShowMessage(true);
                                this.operationResult.setSuccess(true);
                                this.operationResult.setMessage("下推资产变更单成功");
                                OperationResult submitResult = OperationServiceHelper.executeOperate("submit", "fa_change_dept",saveResult.getSuccessPkIds().toArray(),OperateOption.create());
                                OperationResult auditResult = OperationServiceHelper.executeOperate("audit", "fa_change_dept",submitResult.getSuccessPkIds().toArray(),OperateOption.create());
                            }else {
                                this.operationResult.setShowMessage(true);
                                this.operationResult.setSuccess(false);
                                this.operationResult.setMessage("下推资产变更单失败");
                            }
                        }
                    }
                }
            }
        }
    }
}
